import java.time.Duration;
import javax.sql.DataSource;

import net.javacrumbs.shedlock.core.LockProvider;
import net.javacrumbs.shedlock.provider.jdbctemplate.JdbcTemplateLockProvider;
import net.javacrumbs.shedlock.spring.ScheduledLockConfiguration;
import net.javacrumbs.shedlock.spring.ScheduledLockConfigurationBuilder;

import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.EnableAspectJAutoProxy;
import org.springframework.context.annotation.FilterType;
import org.springframework.context.support.PropertySourcesPlaceholderConfigurer;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.concurrent.ThreadPoolTaskScheduler;
import org.springframework.web.servlet.config.annotation.EnableWebMvc;

/**
 * Root application context
 * This context imports XML configs from all the other jars, and is created by {@link WebAppInitializer}
 * NB: modules are excluded from component scan since spring-context.xml sometimes holds important parameters and / or annotations
 * @author krylov
 */
@Configuration
@ComponentScan(basePackages = {
    "service",
    "dao",
    "bpmn",
    "i18n",
    "errorhandling",
    "database",
    "component.addresses",
    "gen",
    "ru.cg",
    "ru.micord"
}, excludeFilters = {
    @ComponentScan.Filter(type = FilterType.REGEX, pattern = "security.WebSecurityConfig")
})
@EnableAspectJAutoProxy(proxyTargetClass = true)
@EnableWebMvc
@EnableScheduling
public class AppConfig {

  @Bean
  public PropertySourcesPlaceholderConfigurer propertySourcesPlaceholderConfigurer(){
    return new PropertySourcesPlaceholderConfigurer();
  }

  @Bean
  public ScheduledLockConfiguration taskScheduler(LockProvider lockProvider) {
    ThreadPoolTaskScheduler scheduler = new ThreadPoolTaskScheduler();
    scheduler.setPoolSize(12);
    scheduler.initialize();
    return ScheduledLockConfigurationBuilder
        .withLockProvider(lockProvider)
        .withTaskScheduler(scheduler)
        .withDefaultLockAtMostFor(Duration.ofHours(4))
        .build();
  }

  @Bean
  public LockProvider lockProvider(@Qualifier("datasource") DataSource dataSource) {
    return new JdbcTemplateLockProvider(dataSource);
  }
}
